Attribute VB_Name = "Module1"
' BY CUQ
'Le port srie utilise un connecteur DB9 (9 broches).
'
'
'DB9
'
'                  -------------------------------
'                  \ 1     2      3     4    5   /
'                   \  O     O     O     O    O /
'                    \   6     7      8    9   /
'                     \   O     O     O    O  /
'                      -----------------------
'
'
'Afin que les lments (un metteur et un rcepteur) qui communiquent ensemble puissent se comprendre, il est ncessaire d'tablir un protocole de transmission. Ce protocole devra tre le mme pour les deux lments afin que la transmission fonctionne correctement.
'Il existe de nombreux protocoles de transmission de donnes qui utilisent le port srie dont le plus connus est le protocole RS232 qui est devenu un standard. Ce protocole fixe aux diffrentes broches d'entres et de sorties des fonctions particulires.
'
'Broche E/S Dsignation Description
'1 Entre DCD (Data Carrier Detect) Dtection de porteuse.
'2 Entre RXD ou RD (Receive Data) Rception de donnes.
'3 Sortie TXD ou TD (Request Data) Emission de donnes.
'4 Sortie DTR (Data Terminal Ready) Terminal prt.
'5 - GND (Ground) Masse.
'6 Entre DSR (Data Set Ready) Emmission prte.
'7 Sortie RTS (Request To Send) Demande d'emmission.
'8 Entre CTS (Clear To Send)  Prt  emettre.
'9 Entre  RI (Ring Indicator) Indicateur de sonnerie.

Declare Function OPENCOM Lib "RSCOM" (ByVal OpenString$) As Integer ' Ouvrir le port com
                                                          ' La chaine de caractres permet de spcifier les paramtres
                                                          '  NUMERO DU PORT (COM1,COM2)
                                                          ' - la vitesse de transmission (par exemple 9600 bauds, bits par secondes)
                                                          ' - la parit (paire ou impaire)
                                                          ' - la longueur des mots (8 bits)
                                                          ' - le bit de stop (1, 1/2 ou 2 bits)
                                                          ' OPENCOM("COM1,1200,N,8,1")
                                                          'Gnralement, les conventions sont les suivantes :

                                                            'COM2 : numro du port
                                                            '9600 : vitesse de transmission en bauds
                                                            'N : pas de parit N=None, paire E=Even, impaire O=Odd, toujours  1 M=Mark, toujours  0 S=Space
                                                            '8 : taille de la donne (entre 5 et 8)
                                                            '1 : nombre de bits de stop (1 ou 1,5 ou 2)

Declare Sub CLOSECOM Lib "RSCOM" ()                         'fermer le port com

Declare Sub SENDBYTE Lib "RSCOM" (ByVal Dat%)                ' Envoyer un caratre
Declare Function READBYTE Lib "RSCOM" () As Integer        ' Lire un caratre

Declare Sub DTR Lib "RSCOM" (ByVal b%)                     '  Terminal prt.             broche 4  (0/1)
Declare Sub RTS Lib "RSCOM" (ByVal b%)                     '  Demande d'emmission.       broche 7  (0/1)
Declare Sub TXD Lib "RSCOM" (ByVal b%)                     '  Emission de donnes.       broche 3  (0/1)

Declare Function CTS Lib "RSCOM" () As Integer             '  Prt  emettre.            broche 8  (0/1)
Declare Function DSR Lib "RSCOM" () As Integer             '  Emmission prte.           broche 6  (0/1)
Declare Function RI Lib "RSCOM" () As Integer              '  Indicateur de sonnerie.    broche 9  (0/1)
Declare Function DCD Lib "RSCOM" () As Integer             '  Dectection de porteuse.    broche 1  (0/1)





Declare Sub SENDSTRING Lib "RSCOM" (ByVal Dat$)            ' Envoyer une chaine
Declare Function READSTRING Lib "RSCOM" () As String       ' Relire une chaine

Declare Sub CLEARBUFFER Lib "RSCOM" ()                     ' Nettoye le buffer en entre

Declare Function INBUFFER Lib "RSCOM" () As Integer        ' Nombre de caractre dans le buffer d'entr
Declare Function OUTBUFFER Lib "RSCOM" () As Integer       ' Nombre de caractre dans le buffer de sortie ?

Declare Sub TIMEOUTS Lib "RSCOM" (ByVal b%)                 ' depassement du temps ?
Declare Sub BUFFERSIZE Lib "RSCOM" (ByVal b%)               ' Change la taille du buffer Taille du buffer

Declare Function INPUTS Lib "RSCOM" () As Integer       '?

Declare Sub TIMEINIT Lib "RSCOM" ()                    ' Reinit le temps
Declare Function TIMEREAD Lib "RSCOM" () As Double     ' donne le temps d'ouverture du port ?

Declare Sub DELAY Lib "RSCOM" (ByVal ms As Double)      'delai en micro seconde // duree d'un bit


Declare Sub REALTIME Lib "RSCOM" ()
Declare Sub NORMALTIME Lib "RSCOM" ()


' Function prsentes dans port et pas dans RSCOMM
Declare Function TIMEREADUS Lib "Port" () As Long
Declare Sub DELAYUS Lib "Port" (ByVal l As Long)
Declare Sub TIMEINITUS Lib "Port" ()


